SystemOrganization addCategory: #ConfigurationOfDBPedia!

Object subclass: #ConfigurationOfDBPedia
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfDBPedia'!

!ConfigurationOfDBPedia commentStamp: '<historical>' prior: 0!
Copy me to create a new configuration or edit and evaluate the following doits.

        "Create configuration class and initial baseline method"

        MetacelloToolBox 
                createBaseline: '1.0-baseline'
                for: 'MyProject'
                repository: 'http://www.example.com/MyProjectRepository'
                requiredProjects: #('Gofer')
                packages: #('MyProject-Core' 'MyProject-Tests')
                dependencies:
                        {('MyProject-Core' -> #('Gofer')).
                         ('MyProject-Tests' -> #('MyProject-Core'))}
                groups:
                        {('default' -> #('Core')).
                        ('Core' -> #('MyProject-Core')).
                        ('Tests' -> #('MyProject-Tests'))}.

	   "create initial development method from the baseline"

         MetacelloToolBox
               createDevelopment: '1.0'
               for: 'MyProject'
                importFromBaseline: '1.0-baseline'
                description: 'initial version'.
!

!ConfigurationOfDBPedia class methodsFor: 'development support' stamp: 'HernanMoralesDurand 3/2/2014 15:19'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfDBPedia class methodsFor: 'private' stamp: 'HernanMoralesDurand 3/2/2014 15:19'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfDBPedia class methodsFor: 'private' stamp: 'HernanMoralesDurand 3/2/2014 15:19'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfDBPedia class methodsFor: 'private' stamp: 'HernanMoralesDurand 3/2/2014 15:19'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfDBPedia class methodsFor: 'metacello tool support' stamp: 'HernanMoralesDurand 3/2/2014 15:19'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfDBPedia class methodsFor: 'loading' stamp: 'HernanMoralesDurand 3/2/2014 15:19'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfDBPedia class methodsFor: 'loading' stamp: 'HernanMoralesDurand 3/2/2014 15:19'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfDBPedia class methodsFor: 'loading' stamp: 'HernanMoralesDurand 3/2/2014 15:19'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfDBPedia class methodsFor: 'accessing' stamp: 'HernanMoralesDurand 3/2/2014 15:19'!
project

	^self new project! !

!ConfigurationOfDBPedia class methodsFor: 'development support' stamp: 'HernanMoralesDurand 3/2/2014 15:19'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfDBPedia methodsFor: 'baselines' stamp: 'HernanMoralesDurand 3/2/2014 15:34'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://www.smalltalkhub.com/mc/hernan/DBPedia/main'.
		spec package: 'DBPedia'.
		spec group: 'default' with: #('DBPedia'). ].
! !

!ConfigurationOfDBPedia methodsFor: 'catalog' stamp: 'HernanMoralesDurand 3/2/2014 15:30'!
catalogChangeLog
	"Returns a paragraph describing the most important changes in the configuration class."
	^ '[[[
	ConfigurationOfDBPedia project version: ''stable'' ) load					
]]]
'! !

!ConfigurationOfDBPedia methodsFor: 'catalog' stamp: 'HernanMoralesDurand 3/2/2014 15:21'!
catalogContactInfo
	"Returns a paragraph describing contact information such as email, mailing lists and website."

	^ 'You can get in contact with me at hernan.morales@gmail.com'! !

!ConfigurationOfDBPedia methodsFor: 'catalog' stamp: 'HernanMoralesDurand 3/2/2014 15:21'!
catalogDescription
	"Returns a paragraph describing the project"

	^ 'Query the Wikipedia dataset from Pharo using SPARQL.'! !

!ConfigurationOfDBPedia methodsFor: 'catalog' stamp: 'HernanMoralesDurand 3/2/2014 15:29'!
catalogKeyClassesAndExample
	"Returns a paragraph or more describing the key classes of your project. You can use Pillar/Pier syntax to layout out the text i.e., ==Code== and - for bullet."
	^ '== DBPediaSearch == is the main class and entry point for executing queries. 
	
== Examples ==

- Retrieve in JSON movies from the beautiful Julianne Moore:

[[[ 
| jsonResults |
jsonResults := DBPediaSearch new
        setJsonFormat;
        timeout: 5000;
        query: ''SELECT DISTINCT ?filmName WHERE {
  ?film foaf:name ?filmName .
  ?film dbpedia-owl:starring ?actress .
  ?actress foaf:name ?name.
  FILTER(contains(?name, "Julianne"))
  FILTER(contains(?name, "Moore"))
}'';
        execute
]]]

- Retrieve in XML which genre plays those crazy Dream Theater guys

[[[
DBPediaSearch new
        setXmlFormat;
        setDebugOn;
        timeout: 5000;
        query: ''SELECT DISTINCT ?genreLabel
WHERE {
    ?resource dbpprop:genre ?genre.
    ?resource rdfs:label "Dream Theater"@en.
    ?genre rdfs:label ?genreLabel
    FILTER (lang(?genreLabel)="en")
}
 LIMIT 100'';
        execute
]]]

See the class side for additional examples.
'! !

!ConfigurationOfDBPedia methodsFor: 'catalog' stamp: 'HernanMoralesDurand 3/2/2014 15:22'!
catalogKeywords
	"Returns an array of symbols"

	^ #(semantic sparql dbpedia wikipedia web linked data) ! !

!ConfigurationOfDBPedia methodsFor: 'accessing' stamp: 'HernanMoralesDurand 3/2/2014 15:19'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfDBPedia methodsFor: 'accessing' stamp: 'HernanMoralesDurand 3/2/2014 15:19'!
project

	^ project ifNil: [ 
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfDBPedia methodsFor: 'symbolic versions' stamp: 'HernanMoralesDurand 3/2/2014 15:33'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfDBPedia methodsFor: 'versions' stamp: 'HernanMoralesDurand 3/2/2014 15:33'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: ''.
		spec author: 'HernanMoralesDurand'.
		spec timestamp: '2/3/2014 04:47'.
		spec package: 'DBPedia' with: 'DBPedia-HernanMoralesDurand.3'. ].
! !
